'use client'
import { useMutation } from '@tanstack/react-query'
import { UpdateBuildIbansUpdate } from './types';
import { toISOIfNotZ } from '@/lib/utils';

const fetchGraphQlBuildIbansUpdate = async (record: UpdateBuildIbansUpdate, uuid: string): Promise<{ data: UpdateBuildIbansUpdate | null; status: number }> => {
    console.log('Fetching test data from local API');
    record.expiryStarts = record.expiryStarts ? toISOIfNotZ(record.expiryStarts) : undefined;
    record.expiryEnds = record.expiryEnds ? toISOIfNotZ(record.expiryEnds) : undefined;
    record.startDate = toISOIfNotZ(record.startDate);
    record.stopDate = toISOIfNotZ(record.stopDate);
    try {
        const res = await fetch(`/api/build-ibans/update?uuid=${uuid || ''}`, { method: 'POST', cache: 'no-store', credentials: "include", body: JSON.stringify(record) });
        if (!res.ok) { const errorText = await res.text(); console.error('Test data API error:', errorText); throw new Error(`API error: ${res.status} ${res.statusText}`) }
        const data = await res.json();
        return { data: data.data, status: res.status }
    } catch (error) { console.error('Error fetching test data:', error); throw error }
};

export function useUpdateBuildIbansMutation() {
    return useMutation({
        mutationFn: ({ data, uuid }: { data: UpdateBuildIbansUpdate, uuid: string }) => fetchGraphQlBuildIbansUpdate(data, uuid),
        onSuccess: () => { console.log("Build IBANs updated successfully") },
        onError: (error) => { console.error("Update Build IBANs failed:", error) },
    })
}
